<?php

// display plugin Settings page
function dk_speakup_settings_page() {
	// check security: ensure user has authority
	if ( !current_user_can( 'manage_options' ) ) wp_die( 'Insufficient privileges: You need to be an administrator to do that.' );

	$options = get_option( 'dk_speakup_options' );
	$page_title =  __( 'Email Petitions Settings', 'email-petition' );
	$action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : '';
	$message_update = '';

	switch( $action ) {
		case 'update' :
			// security: ensure user has intention
			check_admin_referer( 'dk_speakup-update_settings' );

			$allowed_tags = array(
				'a' => array( 'href' => array(),'title' => array() ),
				'em' => array(),
				'strong' => array(),
				'p' => array()
			);

			$options = array(
				'petitions_rows' => absint( $_POST['petitions_rows'] ),
				'signatures_rows' => absint( $_POST['signatures_rows'] ),
				'petition_theme' => $_POST['petition_theme'],
				'petition_header' => esc_html( stripslashes( $_POST['petition_header'] ) ),
				'button_text' => esc_html( stripslashes( $_POST['button_text'] ) ),
				'expiration_message' => esc_html( stripslashes( $_POST['expiration_message'] ) ),
				'success_message' => wp_kses( stripslashes( $_POST['success_message'] ), $allowed_tags ),
				'already_signed_message' => esc_html( stripslashes( $_POST['already_signed_message'] ) ),
				'share_message' => esc_html( stripslashes( $_POST['share_message'] ) ),
				'confirm_subject' => esc_html( $_POST['confirm_subject'] ),
				'confirm_message' => esc_html( stripslashes( $_POST['confirm_message'] ) ),
				'confirm_email' => stripslashes( $_POST['confirm_email'] )
			);
			update_option( 'dk_speakup_options', $options );

			// set up form values
			$petitions_rows = $options['petitions_rows'];
			$signatures_rows = $options['signatures_rows'];
			$petition_theme = $options['petition_theme'];
			$petition_header = $options['petition_header'];
			$button_text = $options['button_text'];
			$expiration_message = $options['expiration_message'];
			$success_message = $options['success_message'];
			$already_signed_message = $options['already_signed_message'];
			$share_message = $options['share_message'];
			$confirm_subject = $options['confirm_subject'];
			$confirm_message = $options['confirm_message'];
			$confirm_email = $options['confirm_email'];
			$nonce = 'dk_speakup-update_settings';
			$action = 'update';
			$message_update = __( 'Settings updated.', 'dk_speakup' );
			break;

		default :
			// set up form values
			$petitions_rows = $options['petitions_rows'];
			$signatures_rows = $options['signatures_rows'];
			$petition_theme = $options['petition_theme'];
			$petition_header = $options['petition_header'];
			$button_text = $options['button_text'];
			$expiration_message = $options['expiration_message'];
			$success_message = $options['success_message'];
			$already_signed_message = $options['already_signed_message'];
			$share_message = $options['share_message'];
			$confirm_subject = $options['confirm_subject'];
			$confirm_message = $options['confirm_message'];
			$confirm_email = $options['confirm_email'];
			$nonce = 'dk_speakup-update_settings';
			$action = 'update';
	}

	include_once( dirname( __FILE__ ) . '/admin-settings-view.php' );
}

?>